#!/usr/bin/python3

import jessentials
import jfiles
import jfolders


def create_found_lines_file(file_path, search_phrase):
    print("Creating found_phrases.txt...")

    line_numbers = jfiles.get_line_numbers_with_phrase(file_path, search_phrase)
    all_lines = jfiles.get_all_lines_from_file(file_path)

    found_lines = []
    for line_number in line_numbers:
        found_lines.append(all_lines[line_number-1].replace("\n", ""))

    found_lines = jessentials.remove_duplicates(found_lines)

    jfiles.write_lines_to_file("found_phrases.txt", found_lines)
    jfiles.write_lines_to_file("replace_phrases.txt", found_lines)
    pass


def replace_to(file_path, output_path):
    print("Replacing....")
    original_lines = jfiles.get_all_lines_from_file("found_phrases.txt")
    replace_lines = jfiles.get_all_lines_from_file("replace_phrases.txt")
    if original_lines == [] or replace_lines == []:
        jessentials.fail("You have to search for a phrase before! Example: --search-for_phrase=obj")
    if len(original_lines) != len(replace_lines):
        jessentials.fail("found_phrases.txt has different line numbers to replace_phrases.txt! Plase make sure every line of found_phrases has a 'replace line' in replace_phrases.txt")
    jfiles.copy_file(file_path, output_path)
    for i in range(len(original_lines)):
        jfiles.replace_lines_in_file(output_path, original_lines[i], replace_lines[i])

def print_help():
    jessentials.fail("How to use:\n\n1. replacer.py --file-to-edit=file.txt --search-phrase=obj\n2. define replacement_lines in replace_phrases.txt\n3. replacer.py --file-to-edit=file.txt --output=output.txt")


def main():
    file_path = jessentials.get_value_from_arguments("file-to-edit", "")
    print(file_path)
    if file_path == "" or not jessentials.does_file_exist(file_path):
        print_help()

    search_phrase = jessentials.get_value_from_arguments("search-phrase", "")
    if search_phrase != "":
        create_found_lines_file(file_path, search_phrase)
        return

    output_path = jessentials.get_value_from_arguments("output", "")
    if output_path != "":
        replace_to(file_path, output_path)
        return

    print_help()

if __name__ == "__main__":
    main()
